config/routes.rb
# Software Name : NIF TZ
# SPDX-FileCopyrightText: Copyright (c) Orange SA
# SPDX-License-Identifier: Apache-2.0
#
# This software is distributed under the Apache-2.0
# ,
# See the "LICENSES" directory for more details.
#
# Authors:
# - Efflam Castel <efflam.castel@orange.com>

# frozen_string_literal: true

# rubocop: disable Metrics/BlockLength
Rails.application.routes.draw do
  resources :results, only: %i[index show]

  get '/metrics', to: 'prometheus#metrics'

  namespace :api do
    namespace :v1 do
      resources :pods, only: %i[index create show], param: :name

      resources :projects, param: :name do
        resources :test_cases, path: 'cases', param: :name
      end

      resources :scenarios, only: [:update], param: :old_name

      resources :scenarios, except: [:update], param: :name do
        resources :installers, only: [:create]
        put 'owner', to: 'scenarios#update_owner'
        resources :versions, only: [:create]
        resources :installer_version_projects, only: [:create], path: 'projects'
        resources :customs, only: [:create]
        resources :ivp_scores, only: [:create], path: 'scores'
        resources :trust_indicators, only: [:create]

        delete 'customs', to: 'customs#destroy'
        delete 'projects', to: 'installer_version_projects#destroy'
        delete 'versions', to: 'versions#destroy'
        delete 'installers', to: 'installers#destroy'

        put 'installers', to: 'installers#update'
        put 'versions', to: 'versions#update'
        put 'projects', to: 'installer_version_projects#update'
        put 'customs', to: 'customs#update'
      end

      resources :results, only: %i[create index show]

      resources :deploy_results, only: %i[create index show], path: 'deployresults'
    end
  end

  root to: 'results#index'
end
# rubocop: enable Metrics/BlockLength

app/models/result.rb
# Software Name : NIF TZ
# SPDX-FileCopyrightText: Copyright (c) Orange SA
# SPDX-License-Identifier: Apache-2.0
#
# This software is distributed under the Apache-2.0
# ,
# See the "LICENSES" directory for more details.
#
# Authors:
# - Efflam Castel <efflam.castel@orange.com>

# frozen_string_literal: true

class Result < ApplicationRecord
  belongs_to :pod
  belongs_to :test_case
  belongs_to :installer_version_project

  attribute :details, default: {}

  def case_name
    test_case.name
  end

  delegate :scenario_name, to: :installer_version_project
  delegate :installer_name, to: :installer_version_project
  delegate :version, to: :installer_version_project

  delegate :project_name, to: :installer_version_project

  delegate :name, to: :pod, prefix: true

  def self.passed
    where(criteria: 'PASS')
  end

  def self.failed
    where(criteria: 'FAIL')
  end

  def duration
    stop_date - start_date
  end

  def passed?
    criteria == 'PASS'
  end

  def links
    if details.instance_of?(Hash)
      details.fetch('links') { [] }
    else
      []
    end
  end

  def authorized?(groups)
    groups.include?(Rails.configuration.admin_group) || groups.any? { |group| group.start_with?(build_tag) }
  end

  def self.sql_duration_in_seconds
    if ActiveRecord::Base.connection.adapter_name.downcase == 'postgresql'
      'EXTRACT(EPOCH FROM (results.stop_date - results.start_date))'
    elsif ActiveRecord::Base.connection.adapter_name.downcase == 'sqlite'
      'unixepoch(results.stop_date) - unixepoch(results.start_date)'
    end
  end
end

app/controllers/api/v1/results_controller.rb
# Software Name : NIF TZ
# SPDX-FileCopyrightText: Copyright (c) Orange SA
# SPDX-License-Identifier: Apache-2.0
#
# This software is distributed under the Apache-2.0
# ,
# See the "LICENSES" directory for more details.
#
# Authors:
# - Efflam Castel <efflam.castel@orange.com>

# frozen_string_literal: true

module API
  module V1
    class ResultsController < APIController
      PAGE_SIZE = 20

      before_action :load_hierarchy, only: :create

      def create
        @result = Result.new(result_params)
        @result.pod = @pod
        @result.test_case = @case
        @result.installer_version_project = @installer_version_project

        @result.details = params[:details]

        if @result.save
          render json: { href: api_v1_result_path(@result) }, status: 201
        else
          render json: @result.errors, status: 400
        end
      end

      def index
        @results = Result.order(created_at: :desc)
        filter_results(params)

        render json: {
                 pagination: {
                   current_page: page_param,
                   total_pages:
                 },
                 results: @results[(page_param - 1) * PAGE_SIZE..page_param * PAGE_SIZE - 1]
               },
               status: 200
      end

      def show
        @result = Result.find(params[:id])

        render json: @result
      end

      private

      def load_hierarchy
        @pod = Pod.find_by(name: params[:pod_name])
        @project = Project.find_by(name: params[:project_name])
        @case = TestCase.find_by(name: params[:case_name], project: @project)
        load_or_create_ivp
      end

      def load_or_create_ivp
        @scenario = Scenario.find_or_create_by(name: params[:scenario])
        @installer = Installer.find_or_create_by(installer: params[:installer], scenario: @scenario)
        @version = InstallerVersion.find_or_create_by(version: params[:version], installer: @installer)
        @installer_version_project = InstallerVersionProject.find_or_create_by(
          project: @project,
          installer_version: @version
        )
      end

      FILTERS = {
        case: ->(result, value) { result.case_name == value },
        buildTag: ->(result, value) { result.build_tag == value },
        scenario: ->(result, value) { result.scenario_name == value },
        project: ->(result, value) { result.project_name == value },
        criteria: ->(result, value) { result.criteria == value },
        pod: ->(result, value) { result.pod_name == value },
        installer: ->(result, value) { result.installer_name == value },
        from: ->(result, date) { result.start_date > date },
        to: ->(result, date) { result.stop_date > date },
        last: ->(result, days) { result.start_date > DateTime.now - days.to_i.days }
      }.freeze

      def filter_results(params)
        params.select { |key| FILTERS.keys.include? key.to_sym }.each do |key, filter|
          @results = @results.select { |result| FILTERS[key.to_sym].call(result, filter) }
        end
      end

      def result_params
        params.permit(%i[criteria start_date stop_date build_tag details page])
      end

      def page_param
        params.permit(:page)
        (params[:page] || 1).to_i
      end

      def total_pages
        (@results.size % PAGE_SIZE).zero? ? @results.size / PAGE_SIZE : @results.size / PAGE_SIZE + 1
      end
    end
  end
end

app/controllers/results_controller.rb
# Software Name : NIF TZ
# SPDX-FileCopyrightText: Copyright (c) Orange SA
# SPDX-License-Identifier: Apache-2.0
#
# This software is distributed under the Apache-2.0
# ,
# See the "LICENSES" directory for more details.
#
# Authors:
# - Efflam Castel <efflam.castel@orange.com>

# frozen_string_literal: true

class ResultsController < ApplicationController
  def show
    @result = Result.find(params[:id])
    return if @result.authorized?(groups)

    head :forbidden
  end

  def index
    @results = Result.left_outer_joins(test_case: :tags)
                     .where(filters)
                     .order(created_at: :desc)
    rbac_filter
    @results = @results.page params[:page]
    @tags = Tag.all
  end

  def search_date_range
    return (Date.today)..(Date.today + 1.days) unless params['[from(1i)]']

    search_from..search_to
  end

  private

  def rbac_filter
    return unless Rails.application.config.rbac_enabled && !groups.include?(Rails.application.config.admin_group)

    @results = @results.select { |result| groups.any? { |group| group.start_with?(result.build_tag) } }
    @results = Kaminari.paginate_array(@results)
  end

  def filters
    filters = {
      start_date: search_date_range,
      stop_date: search_date_range
    }
    filters[:tags] = { value: params['tags'] } if !params['tags'].nil? && !params['tags'].empty?
    filters
  end

  def search_from
    Date.new(
      params['[from(1i)]'].to_i,
      params['[from(2i)]'].to_i,
      params['[from(3i)]'].to_i
    )
  end

  def search_to
    Date.new(
      params['[to(1i)]'].to_i,
      params['[to(2i)]'].to_i,
      params['[to(3i)]'].to_i
    ) + 1.days
  end
end

app/views/results/_filters.html.erb
<%= form_with url: results_path, method: 'get', class: 'row' do |form| %>
  <div class="row">
    <%= render 'tags', tags: tags %>
  </div>
  
  <div class="row">
    <div class="col m-auto">
      <%= form.label :from %>
    </div>

    <%= form.date_select :from,
      {
        order: [:day, :month, :year],
        default: {
          day: request.query_parameters["[from(3i)]"],
          month: request.query_parameters["[from(2i)]"],
          year: request.query_parameters["[from(1i)]"]
        }
      }, 
      {
        class: 'form-select col'
      }
    %>

    <div class="col m-auto">
      <%= form.label :to %>
    </div>

    <%= form.date_select :to, 
      {
        order: [:day, :month, :year],
        default: {
          day: request.query_parameters["[to(3i)]"],
          month: request.query_parameters["[to(2i)]"],
          year: request.query_parameters["[to(1i)]"]
        }
      },
      {
        class: 'form-select col'
      }
    %>

    <div class="col m-auto">
      <%= form.submit 'Filter', class: "btn btn-primary" %>
    </div>
  </div>

<% end %>

app/views/results/_links.html.erb
<% if !@result.links.empty? %>
  <div class="row">
    <div class="col-2 fw-bold">Links:</div>
  </div>
  <% @result.links.each do |link| %>
    <div class="row">
      <div class="col offset-2">
        <a href="<%= link %>" target="_blank"><%= link %></a>
      </div>
    </div>
  <% end %>
<% end %>

app/views/results/_result.html.erb
<tr class="result-row">
  <th scope="row"><%= link_to result.id, result_path(result.id) %></th>
  <th><%= result.pod_name %></th>
  <th><%= result.project_name %></th>
  <th
    data-bs-toggle="tooltip"
    title="<%= result.case_name %>"
  >
    <%= result.case_name.truncate(25) %>
  </th>
  <th><%= result.start_date %></th>
  <th><%= result.stop_date %></th>
  <th
    data-sort="<%= result.duration %>"
  >
  <%= distance_of_time_in_words(result.start_date, result.stop_date, include_seconds: true) %>
  </th>
  <th><%= result.criteria %></th>
  <th><%= result.build_tag %></th>
</tr>

app/views/results/_tags.html.erb
<div class="accordion" id="tagListAccordion">
  <div class="accordion-item">
    <h3 class="accordion-header" id="tagListHeading">
      <button class="accordion-button" type="button" data-bs-toggle="collapse" data-bs-target="#collapseOne" aria-expanded="false" aria-controls="collapseOne">
        Tags
      </button>
    </h3>
    <div id="collapseOne" class="accordion-collapse collapse show" aria-labelledby="tagListHeading" data-bs-parent="#tagListAccordion">
      <div class="accordion-body">
        <div class="row">
          <% tags.each do |tag| %>
            <div class="col">
              <div class="badge rounded-pill text-bg-secondary">
                <%= check_box_tag 'tags[]', tag.value, (request.parameters["tags"] || []).include?(tag.value) %>
                <%= tag.value %>
              </div>
            </div>
          <% end %>
        </div>
      </div>
    </div>
  </div>  
</div>

app/views/results/index.html.erb
<div class="row">
  <div class="col-2">
    <h2>Results</h2>
  </div>
  <div class="col m-auto">
    <%= paginate @results, theme: 'bootstrap-5', window: 2 %>
  </div>
  <div class="col-3 page-entries m-auto">
    <%= page_entries_info @results %>
  </div>
</div>

<%= render 'filters', tags: @tags %>

<div class="row">
  <table class="table table-striped sortable">
    <thead>
      <tr>
        <th scope="col">#</th>
        <th scope="col">Pod</th>
        <th scope="col">Project</th>
        <th scope="col">Test Case</th>
        <th scope="col">Start</th>
        <th scope="col">End</th>
        <th scope="col">Duration</th>
        <th scope="col">Criteria</th>
        <th scope="col">Build tag</th>
      </tr>
    </thead>
    <tbody>
      <%= render @results %>
    </tbody>
  </table>
</div>

app/views/results/show.html.erb
<div class="container">
  <h2>Result</h2>

  <div class="row">
    <div class="col-2 fw-bold">Id:</div>
    <div class="col"><%= @result.id %></div>
  </div>
  <div class="row">
    <div class="col-2 fw-bold">Pod:</div>
    <div class="col"><%= @result.pod_name %></div>
  </div>
  <div class="row">
    <div class="col-2 fw-bold">Project:</div>
    <div class="col"><%= @result.project_name %></div>
  </div>
  <div class="row">
    <div class="col-2 fw-bold">Case:</div>
    <div class="col"><%= @result.case_name %></div>
  </div>
  <div class="row">
    <div class="col-2 fw-bold">Installer:</div>
    <div class="col"><%= @result.installer_name %></div>
  </div>
  <div class="row">
    <div class="col-2 fw-bold">Version:</div>
    <div class="col"><%= @result.version %></div>
  </div>
  <div class="row">
    <div class="col-2 fw-bold">Scenario:</div>
    <div class="col"><%= @result.scenario_name %></div>
  </div>
  <div class="row">
    <div class="col-2 fw-bold">Build Tag:</div>
    <div class="col"><%= @result.build_tag %></div>
  </div>
  <div class="row">
    <div class="col-2 fw-bold">Criteria:</div>
    <div class="col"><%= @result.criteria %></div>
  </div>
  <div class="row">
    <div class="col-2 fw-bold">Start Date:</div>
    <div class="col"><%= @result.start_date %></div>
  </div>
  <div class="row">
    <div class="col-2 fw-bold">Stop Date:</div>
    <div class="col"><%= @result.stop_date %></div>
  </div>
  <%= render 'links', links: @result.links %>
</div>